#ifndef CTPUZZLE_PUZZLE__
#define CTPUZZLE_PUZZLE__
////////////////////////////////////////////////////////////////////////////////
#include "brick.h"
#include "neighbourhood.h"
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
struct Puzzle
{
    typedef vector<vector<int> > VVI;
    typedef vector<VVI> VVVI;

    static uint chooseCell(const uint *pv,const uint *ps);
    void fillCell(uint bstate);
    void fillCell4();
    void setBrick3();
    void setBrick2();
    void setBrick1();
    void setBrick0();
    void solve(vector<Brick>& b);
    void initMoves(vector<Brick>& b);
    int initBrickRot(vector<Brick>& b,vector<BrickRot>& br);
    void initValue(VVVI& out);
    void timeMessage() const;
    void sizeMessage() const;
    void symmetryMessage() const;
    void statusMessage(const BrickRot& br) const;
    Puzzle();
    ~Puzzle() { clear(); };
    void clear();

    uint state[SUINT];
    const uint ***smoves;
    const uint **bmoves;
    const uint **pmoves;
    uint *moves;
    uint value[NSTATES];

    int hitCount;

    Timer timer;
};
////////////////////////////////////////////////////////////////////////////////
#endif
