////////////////////////////////////////////////////////////////////////////////
#include "timer.h"
#include <time.h>
////////////////////////////////////////////////////////////////////////////////
// time
int utility::unixTime()
{
    time_t ltime;
    time( &ltime );
    return ltime;
}

double utility::getTime(double t0)
{
    return double(clock())/CLOCKS_PER_SEC-t0;
}

////////////////////////////////////////////////////////////////////////////////
// timer
utility::Timer::Timer() { reset(); }

utility::Timer::~Timer() {}

void utility::Timer::reset()
{
    total_ = partial_ = 0;
    started = false;
}

void utility::Timer::start()
{
    if(started) stop();
    started = true;
    partial_ = getTime(0);
}

void utility::Timer::stop()
{
    if(started)
    {
        partial_ = getTime(partial_);
        started = false;
        total_ += partial_;
    }
}

double utility::Timer::total() const
{
    return started ? total_ + getTime(partial_) : total_;
}

double utility::Timer::partial() const
{
    return started ? getTime(partial_) : partial_;
}
////////////////////////////////////////////////////////////////////////////////
