#ifndef UTILITY_TIMER__
#define UTILITY_TIMER__
////////////////////////////////////////////////////////////////////////////////
namespace utility {
////////////////////////////////////////////////////////////////////////////////
// unix-time (seconds since 1st january 1970)
extern int unixTime();
////////////////////////////////////////////////////////////////////////////////
// time(-difference) in seconds
extern double getTime(double=0);
////////////////////////////////////////////////////////////////////////////////
// stop-watch class (time in seconds)
class Timer
{
    double total_, partial_;
    bool started;
public:
    Timer();
    ~Timer();
    void reset();
    void start();
    void stop();
    double total() const; // accumulated time
    double partial() const; // time since last start
};
////////////////////////////////////////////////////////////////////////////////
} // end namespace utility
#endif // UTILITY_TIMER__
